VERSION 5.00
Begin VB.Form Form1 
   AutoRedraw      =   -1  'True
   BorderStyle     =   1  'Fixed Single
   Caption         =   "vbSqlite3"
   ClientHeight    =   5280
   ClientLeft      =   45
   ClientTop       =   375
   ClientWidth     =   9660
   BeginProperty Font 
      Name            =   "Tahoma"
      Size            =   8.25
      Charset         =   0
      Weight          =   400
      Underline       =   0   'False
      Italic          =   0   'False
      Strikethrough   =   0   'False
   EndProperty
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   ScaleHeight     =   352
   ScaleMode       =   3  'Pixel
   ScaleWidth      =   644
   StartUpPosition =   2  'CenterScreen
   Begin VB.CommandButton Command2 
      Caption         =   "Explorar  [db]"
      Height          =   495
      Left            =   5160
      TabIndex        =   4
      Top             =   4560
      Width           =   2055
   End
   Begin VB.CommandButton Command1 
      Caption         =   "Recargar"
      Height          =   495
      Left            =   7320
      TabIndex        =   0
      Top             =   4560
      Width           =   2055
   End
   Begin vbSqlite3.JGridLite lv 
      Height          =   3495
      Left            =   240
      TabIndex        =   5
      Top             =   840
      Width           =   9135
      _ExtentX        =   16113
      _ExtentY        =   6165
      BackColor       =   16777215
      HeaderH         =   26
      ForeColor       =   0
      HeaderColor     =   16777215
      HeaderBack      =   4210752
      BorderColor     =   8421504
      SelColor        =   33023
   End
   Begin VB.Label Label2 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Powered by J. Elihu"
      ForeColor       =   &H80000015&
      Height          =   195
      Left            =   7920
      TabIndex        =   6
      Top             =   360
      Width           =   1410
   End
   Begin VB.Label Label3 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Plugin version: 1.6"
      ForeColor       =   &H80000015&
      Height          =   195
      Left            =   7920
      TabIndex        =   3
      Top             =   540
      Width           =   1335
   End
   Begin VB.Label lblVersion 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "Version"
      Height          =   195
      Left            =   300
      TabIndex        =   2
      Top             =   480
      Width           =   525
   End
   Begin VB.Label Label1 
      AutoSize        =   -1  'True
      BackStyle       =   0  'Transparent
      Caption         =   "VbSqlite3"
      BeginProperty Font 
         Name            =   "Tahoma"
         Size            =   9.75
         Charset         =   0
         Weight          =   700
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      ForeColor       =   &H00000000&
      Height          =   240
      Left            =   300
      TabIndex        =   1
      Top             =   240
      Width           =   915
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

'\Random Names
Private Const FIRST_NAMES = "Alan,Alison,Alfie,Andrew,Bill,Dawn,Hannah,Brian,David,Jane,Jennifer,Karen,Gavin,Kerry,Kim,James,Laura,Lucy,Michael,Mellisa,Paula,Patrick,Sarah,Emily,Susan"
Private Const LAST_NAMES = "Anderson,Allen,Black,Evans,Bloggs,Brown,Clarke,Cole,Davis,Dawson,Brown,Gate,Johnson,Jones,Lawson,Lee,Richards,Ryan,Smith,Stephens,Temple,Turner,Wallace,White,Williams"

'\Objetos de Sqlite
Private c_Sqlite    As cSqlite
Private c_Cursor    As cSqliteCursor


Private Sub Form_Load()
Dim i   As Long
Dim Sql As String
Dim tmp As String

    '/? Grid Column's
    lv.AddColumn "ID", 50, vbCenter
    lv.AddColumn "FIRST NAME", 150
    lv.AddColumn "LAST NAME", 150
    lv.AddColumn "AGE", 50, vbCenter
    
    
    '/? Opcional -> Cargar Sqlite3.dll desde otra ruta
    'Sqlite3Manage Sql3_Library, App.Path & "\lib\mySql3.dll"
    
    Set c_Sqlite = New cSqlite
  
    'c_Sqlite.SqliteOpen "data.db"              '-> open file db
    'c_Sqlite.SqliteOpen ":memory:"             '-> open memory db
    
    c_Sqlite.SqliteOpen ":memory:"              '-> open memory db
    If c_Sqlite.SqliteErrcode Then SqliteError  '-> Show Custom MSG
    
    'c_Sqlite.Attach "db-2.db3", "users_db"       '-> Attach data base
    'If c_Sqlite.SqliteErrcode Then SqliteError   '-> Show Custom MSG
    
    
    '/USER VERSION
    'c_Sqlite.UserVersion = 2
    'Debug.Print c_Sqlite.UserVersion
    
    
    '/? Configurar WAL MODE
    'c_Sqlite.JournalMode = WAL
    'c_Sqlite.Synchronous = NORMAL_
    
    '/? Configurar DEFAULT MODE
    'c_Sqlite.JournalMode = DELETE_
    'c_Sqlite.Synchronous = FULL
    
    c_Sqlite.ForeignKeys = True

    '/? CREATE TABLES
    'c_Sqlite.Execute "DROP TABLE IF EXISTS users;"
    Sql = "CREATE TABLE IF NOT EXISTS users (id INTEGER PRIMARY KEY AUTOINCREMENT, first_name TEXT DEFAULT elihu, last_name TEXT DEFAULT flores, age INTEGER, picture BLOB);"
    If c_Sqlite.Execute(Sql) <> SQLITE_OK Then SqliteError '-> Show Custom MSG
    
    Sql = "CREATE VIEW IF NOT EXISTS view1  AS SELECT first_name, last_name FROM users;"
    If c_Sqlite.Execute(Sql) <> SQLITE_OK Then SqliteError '-> Show Custom MSG
    
    Sql = "CREATE TABLE user_logs (id INTEGER PRIMARY KEY AUTOINCREMENT, time_stamp TEXT, user_name TEXT);"
    If c_Sqlite.Execute(Sql) <> SQLITE_OK Then SqliteError '-> Show Custom MSG
    
    '/Trigger
    'Sql = "CREATE TRIGGER insert_users BEFORE INSERT ON users BEGIN INSERT INTO user_logs(time_stamp,user_name) VALUES(current_date,NEW.first_name); END;"
    'If c_Sqlite.Execute(Sql) <> SQLITE_OK Then SqliteError '-> Show Custom MSG
    
    '/SQL desde archivo
    If c_Sqlite.Execute(get_sql_file("trigger.sql")) <> SQLITE_OK Then SqliteError                          '-> Show Custom MSG
    If c_Sqlite.Execute("CREATE INDEX user_index ON users (id,first_name);") <> SQLITE_OK Then SqliteError  '-> Show Custom MSG
    


    'INSERTAR DATOS 'binding':
    Set c_Cursor = c_Sqlite.Query("INSERT INTO users (first_name,last_name,age,picture) VALUES (:arg1,:arg2,:age,:avatar);")
    If c_Sqlite.SqliteErrcode Then SqliteError '-> Show Custom MSG
    For i = 1 To 25
    
        '\? Para usar binding:
        '   -   c_cursor.Bind 1, "some value"        -> index del campo      [1, 2, 3 ,4]
        '   -   c_cursor.Bind ":arg1", "some value"  -> nombre del campo     [:arg1, :arg2, :arg3, :arg4 ]
        
        c_Cursor.Bind 1, get_first_name
        c_Cursor.Bind ":arg2", get_last_name & " " & get_last_name
        c_Cursor.Bind ":age", get_random_num(60), Sql3Int
        c_Cursor.Bind 4, get_picture_bytes(), Sql3Blob  '-> Bind a Image Bytes
        
        If c_Cursor.Step <> SQLITE_DONE Then SqliteError: Exit For  '->Show Custom MSG
        c_Cursor.Reset
        
        '\? Obtener la ID del registro insertado
        'Debug.Print "Inserted ID: " & c_Cursor.LastInsertID
    Next

    '\? SINGLE QUERY
    Set c_Cursor = c_Sqlite.Query("SELECT id FROM users WHERE first_name='Elihu' AND last_name='Flores';")
    If c_Cursor.Step = SQLITE_ROW Then
        'Debug.Print "login authorized: 'Elihu'"
    Else
        'Debug.Print "login not authorized"
    End If

    
    
    '\? DATA QUERY
    Set c_Cursor = c_Sqlite.Query("SELECT * FROM users;")
    Do While c_Cursor.Step = SQLITE_ROW
    
        '\? Para obtener los datos:
        '   -   c_cursor.Value(0)           -> index del campo
        '   -   c_cursor.Value("last_name") -> nombre del campo
  
        lv.AddRow c_Cursor.Value(0), c_Cursor.Value("first_name"), c_Cursor.Value(2), c_Cursor.Value("age")
        
    Loop
    
    
    '\? Eliminar espacios en blanco en la db
    'c_Sqlite.Vacuum
    
    '\? Backup  ||  Copy ':memory:' db  to File
    'c_Sqlite.Backup "backup.db3", Me, 100, True   '-> 100 Pages per step
    'c_Sqlite.Backup "backup.db3", Me, -1, True    '-> All Pages
    'If c_Sqlite.Backup("backup.db3", Me, 4, True) <> SQLITE_OK Then MsgBox "Backup Error", vbCritical
    
    lblVersion = "Lib version: " & c_Sqlite.SqliteVersion
    
End Sub

Private Sub Command1_Click()

    lv.Clear
    c_Cursor.Reset
    Do While c_Cursor.Step = SQLITE_ROW
        lv.AddRow c_Cursor.Value(0), c_Cursor.Value("first_name"), c_Cursor.Value(2), c_Cursor.Value("age")
    Loop
    
End Sub
Private Sub Command2_Click()
    Form2.Show 1, Me
End Sub

'\** Sqlite Backup CallBack **/
Public Sub Sqlite_Backup(Remaining As Long, PageCount As Long, ByVal Result As Sqlite3Result, ByVal zMsg As String)
    If Result = SQLITE_OK Or Result = SQLITE_DONE Then
        Debug.Print "Backup: " & 100 * (PageCount - Remaining) \ PageCount & "%"
    Else
        Debug.Print "Backup Error - " & Result & ": " & zMsg
    End If
End Sub

Private Sub Form_Unload(Cancel As Integer)
    '? IMPORTANTE
    Set c_Cursor = Nothing  '-> 1 - Destruir el objeto de consulta.
    Set c_Sqlite = Nothing  '-> 2 - Destruir el objeto de conexin.
    
End Sub




'/? DEMO - Private Functions


'CUSTOM MSGBOX
Private Function SqliteError() As Boolean
    MsgBox "DATA BASE ERROR" & vbNewLine & String$(25, "-") & vbNewLine & "code : " & c_Sqlite.SqliteErrcode & vbNewLine & "msg  : " & c_Sqlite.SqliteErrmsg, vbCritical, ""
End Function

Property Get Sqlite()
    Set Sqlite = c_Sqlite
End Property


'GET IMAGE BYTES
Private Function get_picture_bytes() As Byte()
On Error GoTo e
Dim FF      As Integer
Dim bb()    As Byte

    FF = FreeFile
    Open App.Path & "\res\user.png" For Binary As #FF
    ReDim bb(LOF(FF) - 1)
    Get #FF, , bb()
    Close #FF
    get_picture_bytes = bb
e:
End Function

Private Function get_sql_file(ByVal SqlFile As String) As String
On Error GoTo e
Dim FF      As Integer
    FF = FreeFile
    Open App.Path & "\sql\" & SqlFile For Binary As #FF
    get_sql_file = Space$(LOF(FF))
    Get #FF, , get_sql_file
    Close #FF
e:
End Function



'/ Get Random Data
Private Function get_first_name() As String
    get_first_name = Split(FIRST_NAMES, ",")(get_random_num(25))
End Function
Private Function get_last_name() As String
    get_last_name = Split(LAST_NAMES, ",")(get_random_num(25))
End Function
Private Function get_random_num(Max As Long)
    Randomize Timer
    get_random_num = Int(Max * Rnd)
End Function
