Attribute VB_Name = "Global"
Option Explicit


Public oSql3_dll        As cLib          '    ->  Global connection -> Sqlite3.dll


Public Function Sqlite3Manage(ByVal Sql3Setup As enmSqlitePlugin, Optional ByVal Sql3Library As String) As Sqlite3Result
Dim bMod            As Boolean
Static Count        As Long
Static last_sqllib  As String

    Select Case Sql3Setup
    
        Case Sql3_Library, Sql3_Startup
        
                If oSql3_dll Is Nothing Then Set oSql3_dll = New cLib
                If Sql3Setup = Sql3_Library And oSql3_dll.Handle <> 0 Then
                    Call oSql3_dll.Func("sqlite3_shutdown"): oSql3_dll.DllUnload
                End If
  
                If Sql3Setup = Sql3_Library Or oSql3_dll.Handle = 0 Then
                
                    If Sql3Library <> vbNullString Then bMod = oSql3_dll.DllLoad(Sql3Library)
                    If bMod = False And (last_sqllib <> vbNullString) Then bMod = oSql3_dll.DllLoad(last_sqllib)
                    
                    If bMod = False Then bMod = oSql3_dll.DllLoad("Sqlite3.dll")
                    If bMod = False Then bMod = oSql3_dll.DllLoad(App.Path & "\Sqlite3.dll")
                
                    If bMod Then Call oSql3_dll.Func("sqlite3_initialize")
                    If bMod And (Sql3Library <> vbNullString) Then last_sqllib = Sql3Library
                    
                    Sqlite3Manage = IIf(bMod, SQLITE_OK, SQLITE_ERROR)
                End If
                
                If Sql3Setup = Sql3_Startup Then Count = Count + 1
                
        Case Sql3_Shutdown
            
            If oSql3_dll Is Nothing Then Exit Function
            If oSql3_dll.Handle = 0 Then Exit Function
            
            Count = Count - 1
            If Count > 0 Then Exit Function
            Sqlite3Manage = oSql3_dll.Func("sqlite3_shutdown")
            Set oSql3_dll = Nothing
            
    End Select
    
End Function

